/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*- */^M
/* ^M
 * The contents of this file are subject to the Mozilla Public^M
 * License Version 1.1 (the "License"); you may not use this file^M
 * except in compliance with the License. You may obtain a copy of^M
 * the License at http://www.mozilla.org/MPL/^M
 * ^M
 * Software distributed under the License is distributed on an "AS^M
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or^M
 * implied. See the License for the specific language governing^M
 * rights and limitations under the License.^M
 * ^M
 * The Original Code is the Netscape Portable Runtime (NSPR).^M
 * ^M
 * The Initial Developer of the Original Code is Netscape^M
 * Communications Corporation.  Portions created by Netscape are ^M
 * Copyright (C) 1998-2000 Netscape Communications Corporation.  All^M
 * Rights Reserved.^M
 * ^M
 * Contributor(s):^M
 * ^M
 * Alternatively, the contents of this file may be used under the^M
 * terms of the GNU General Public License Version 2 or later (the^M
 * "GPL"), in which case the provisions of the GPL are applicable ^M
 * instead of those above.  If you wish to allow use of your ^M
 * version of this file only under the terms of the GPL and not to^M
 * allow others to use your version of this file under the MPL,^M
 * indicate your decision by deleting the provisions above and^M
 * replace them with the notice and other provisions requiored by^M
 * the GPL.  If you do not delete the provisions above, a recipient^M
 * may use your version of this file under either the MPL or the^M
 * GPL.^M
 */^M
^M
#if defined(PLARENAS_H)^M
#else  /* defined(PLARENAS_H) */^M
#define PLARENAS_H^M
^M
PR_BEGIN_EXTERN_C^M
^M
typedef struct PLArenaPool      PLArenaPool;^M
^M
/*^M
** Allocate an arena pool as specified by the parameters.^M
**^M
** This is equivelant to allocating the space yourself and then^M
** calling PL_InitArenaPool().^M
**^M
** This function may fail (and return a NULL) for a variety of^M
** reasons. The reason for a particular failure can be discovered^M
** by calling PR_GetError().^M
*/^M
#if 0  /* Not implemented */^M
PR_EXTERN(PLArenaPool*) PL_AllocArenaPool(^M
    const char *name, PRUint32 size, PRUint32 align);^M
#endif^M
^M
/*^M
** Destroy an arena pool previously allocated by PL_AllocArenaPool().^M
**^M
** This function may fail if the arena is not empty and the caller^M
** wishes to check for empty upon descruction.^M
*/^M
#if 0  /* Not implemented */^M
PR_EXTERN(PRStatus) PL_DestroyArenaPool(PLArenaPool *pool, PRBool checkEmpty);^M
#endif^M
^M
^M
/*^M
** Initialize an arena pool with the given name for debugging and metering,^M
** with a minimum size per arena of size bytes.^M
**/^M
PR_EXTERN(void) PL_InitArenaPool(^M
    PLArenaPool *pool, const char *name, PRUint32 size, PRUint32 align);^M
^M
/*^M
** Finish using arenas, freeing all memory associated with them.^M
**/^M
PR_EXTERN(void) PL_ArenaFinish(void);^M
^M
/*^M
** Free the arenas in pool.  The user may continue to allocate from pool^M
** after calling this function.  There is no need to call PL_InitArenaPool()^M
** again unless PL_FinishArenaPool(pool) has been called.^M
**/^M
PR_EXTERN(void) PL_FreeArenaPool(PLArenaPool *pool);^M
^M
/*^M
** Free the arenas in pool and finish using it altogether.^M
**/^M
PR_EXTERN(void) PL_FinishArenaPool(PLArenaPool *pool);^M
^M
/*^M
** Compact all of the arenas in a pool so that no space is wasted.^M
**/^M
PR_EXTERN(void) PL_CompactArenaPool(PLArenaPool *pool);^M
^M
/*^M
** Friend functions used by the PL_ARENA_*() macros.^M
**/^M
PR_EXTERN(void *) PL_ArenaAllocate(PLArenaPool *pool, PRUint32 nb);^M
^M
PR_EXTERN(void *) PL_ArenaGrow(^M
    PLArenaPool *pool, void *p, PRUint32 size, PRUint32 incr);^M
^M
PR_EXTERN(void) PL_ArenaRelease(PLArenaPool *pool, char *mark);^M
^M
PR_END_EXTERN_C^M
^M
#endif /* defined(PLARENAS_H) */^M
^M
/* plarenas */^M
