/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*- */^M
/* ^M
 * The contents of this file are subject to the Mozilla Public^M
 * License Version 1.1 (the "License"); you may not use this file^M
 * except in compliance with the License. You may obtain a copy of^M
 * the License at http://www.mozilla.org/MPL/^M
 * ^M
 * Software distributed under the License is distributed on an "AS^M
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or^M
 * implied. See the License for the specific language governing^M
 * rights and limitations under the License.^M
 * ^M
 * The Original Code is the Netscape Portable Runtime (NSPR).^M
 * ^M
 * The Initial Developer of the Original Code is Netscape^M
 * Communications Corporation.  Portions created by Netscape are ^M
 * Copyright (C) 1998-2000 Netscape Communications Corporation.  All^M
 * Rights Reserved.^M
 * ^M
 * Contributor(s):^M
 * ^M
 * Alternatively, the contents of this file may be used under the^M
 * terms of the GNU General Public License Version 2 or later (the^M
 * "GPL"), in which case the provisions of the GPL are applicable ^M
 * instead of those above.  If you wish to allow use of your ^M
 * version of this file only under the terms of the GPL and not to^M
 * allow others to use your version of this file under the MPL,^M
 * indicate your decision by deleting the provisions above and^M
 * replace them with the notice and other provisions required by^M
 * the GPL.  If you do not delete the provisions above, a recipient^M
 * may use your version of this file under either the MPL or the^M
 * GPL.^M
 */^M
^M
/*^M
** File:          plgetopt.h^M
** Description:   utilities to parse argc/argv^M
*/^M
^M
#if defined(PLGETOPT_H_)^M
#else^M
#define PLGETOPT_H_^M
^M
#include "prtypes.h"^M
^M
PR_BEGIN_EXTERN_C^M
^M
typedef struct PLOptionInternal PLOptionInternal; ^M
^M
typedef enum^M
{^M
        PL_OPT_OK,              /* all's well with the option */^M
        PL_OPT_EOL,             /* end of options list */^M
        PL_OPT_BAD              /* invalid option (and value) */^M
} PLOptStatus;^M
^M
typedef struct PLOptState^M
{^M
    char option;                /* the name of the option */^M
    const char *value;          /* the value of that option | NULL */^M
^M
    PLOptionInternal *internal; /* private processing state */^M
^M
} PLOptState;^M
^M
PR_EXTERN(PLOptState*) PL_CreateOptState(^M
        PRIntn argc, char **argv, const char *options);^M
^M
PR_EXTERN(void) PL_DestroyOptState(PLOptState *opt);^M
^M
PR_EXTERN(PLOptStatus) PL_GetNextOpt(PLOptState *opt);^M
^M
PR_END_EXTERN_C^M
^M
#endif /* defined(PLGETOPT_H_) */^M
^M
/* plgetopt.h */^M
^M
