/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*- */^M
/* ^M
 * The contents of this file are subject to the Mozilla Public^M
 * License Version 1.1 (the "License"); you may not use this file^M
 * except in compliance with the License. You may obtain a copy of^M
 * the License at http://www.mozilla.org/MPL/^M
 * ^M
 * Software distributed under the License is distributed on an "AS^M
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or^M
 * implied. See the License for the specific language governing^M
 * rights and limitations under the License.^M
 * ^M
 * The Original Code is the Netscape Portable Runtime (NSPR).^M
 * ^M
 * The Initial Developer of the Original Code is Netscape^M
 * Communications Corporation.  Portions created by Netscape are ^M
 * Copyright (C) 1998-2000 Netscape Communications Corporation.  All^M
 * Rights Reserved.^M
 * ^M
 * Contributor(s):^M
 * ^M
 * Alternatively, the contents of this file may be used under the^M
 * terms of the GNU General Public License Version 2 or later (the^M
 * "GPL"), in which case the provisions of the GPL are applicable ^M
 * instead of those above.  If you wish to allow use of your ^M
 * version of this file only under the terms of the GPL and not to^M
 * allow others to use your version of this file under the MPL,^M
 * indicate your decision by deleting the provisions above and^M
 * replace them with the notice and other provisions required by^M
 * the GPL.  If you do not delete the provisions above, a recipient^M
 * may use your version of this file under either the MPL or the^M
 * GPL.^M
 */^M
^M
#ifndef prbit_h___^M
#define prbit_h___^M
^M
#include "prtypes.h"^M
PR_BEGIN_EXTERN_C^M
^M
/*^M
** A prbitmap_t is a long integer that can be used for bitmaps^M
*/^M
typedef unsigned long prbitmap_t;^M
^M
#define PR_TEST_BIT(_map,_bit) \^M
    ((_map)[(_bit)>>PR_BITS_PER_LONG_LOG2] & (1L << ((_bit) & (PR_BITS_PER_LONG-1))))^M
#define PR_SET_BIT(_map,_bit) \^M
    ((_map)[(_bit)>>PR_BITS_PER_LONG_LOG2] |= (1L << ((_bit) & (PR_BITS_PER_LONG-1))))^M
#define PR_CLEAR_BIT(_map,_bit) \^M
    ((_map)[(_bit)>>PR_BITS_PER_LONG_LOG2] &= ~(1L << ((_bit) & (PR_BITS_PER_LONG-1))))^M
^M
/*^M
** Compute the log of the least power of 2 greater than or equal to n^M
*/^M
NSPR_API(PRIntn) PR_CeilingLog2(PRUint32 i); ^M
^M
/*^M
** Compute the log of the greatest power of 2 less than or equal to n^M
*/^M
NSPR_API(PRIntn) PR_FloorLog2(PRUint32 i); ^M
^M
/*^M
** Macro version of PR_CeilingLog2: Compute the log of the least power of^M
** 2 greater than or equal to _n. The result is returned in _log2.^M
*/^M
#define PR_CEILING_LOG2(_log2,_n)   \^M
  PR_BEGIN_MACRO                    \^M
    PRUint32 j_ = (PRUint32)(_n); 	\^M
    (_log2) = 0;                    \^M
    if ((j_) & ((j_)-1))            \^M
	(_log2) += 1;               \^M
    if ((j_) >> 16)                 \^M
	(_log2) += 16, (j_) >>= 16; \^M
    if ((j_) >> 8)                  \^M
	(_log2) += 8, (j_) >>= 8;   \^M
    if ((j_) >> 4)                  \^M
	(_log2) += 4, (j_) >>= 4;   \^M
    if ((j_) >> 2)                  \^M
	(_log2) += 2, (j_) >>= 2;   \^M
    if ((j_) >> 1)                  \^M
	(_log2) += 1;               \^M
  PR_END_MACRO^M
^M
/*^M
** Macro version of PR_FloorLog2: Compute the log of the greatest power of^M
** 2 less than or equal to _n. The result is returned in _log2.^M
**^M
** This is equivalent to finding the highest set bit in the word.^M
*/^M
#define PR_FLOOR_LOG2(_log2,_n)   \^M
  PR_BEGIN_MACRO                    \^M
    PRUint32 j_ = (PRUint32)(_n); 	\^M
    (_log2) = 0;                    \^M
    if ((j_) >> 16)                 \^M
	(_log2) += 16, (j_) >>= 16; \^M
    if ((j_) >> 8)                  \^M
	(_log2) += 8, (j_) >>= 8;   \^M
    if ((j_) >> 4)                  \^M
	(_log2) += 4, (j_) >>= 4;   \^M
    if ((j_) >> 2)                  \^M
	(_log2) += 2, (j_) >>= 2;   \^M
    if ((j_) >> 1)                  \^M
	(_log2) += 1;               \^M
  PR_END_MACRO^M
^M
PR_END_EXTERN_C^M
#endif /* prbit_h___ */^M
