/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*- */^M
/* ^M
 * The contents of this file are subject to the Mozilla Public^M
 * License Version 1.1 (the "License"); you may not use this file^M
 * except in compliance with the License. You may obtain a copy of^M
 * the License at http://www.mozilla.org/MPL/^M
 * ^M
 * Software distributed under the License is distributed on an "AS^M
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or^M
 * implied. See the License for the specific language governing^M
 * rights and limitations under the License.^M
 * ^M
 * The Original Code is the Netscape Portable Runtime (NSPR).^M
 * ^M
 * The Initial Developer of the Original Code is Netscape^M
 * Communications Corporation.  Portions created by Netscape are ^M
 * Copyright (C) 1999-2000 Netscape Communications Corporation.  All^M
 * Rights Reserved.^M
 * ^M
 * Contributor(s):^M
 * ^M
 * Alternatively, the contents of this file may be used under the^M
 * terms of the GNU General Public License Version 2 or later (the^M
 * "GPL"), in which case the provisions of the GPL are applicable ^M
 * instead of those above.  If you wish to allow use of your ^M
 * version of this file only under the terms of the GPL and not to^M
 * allow others to use your version of this file under the MPL,^M
 * indicate your decision by deleting the provisions above and^M
 * replace them with the notice and other provisions required by^M
 * the GPL.  If you do not delete the provisions above, a recipient^M
 * may use your version of this file under either the MPL or the^M
 * GPL.^M
 */^M
^M
^M
/*^M
** prrng.h -- NSPR Random Number Generator^M
** ^M
**^M
** lth. 29-Oct-1999.^M
*/^M
^M
#ifndef prrng_h___ ^M
#define prrng_h___^M
^M
#include "prtypes.h"^M
^M
PR_BEGIN_EXTERN_C^M
^M
/*^M
** PR_GetRandomNoise() -- Get random noise from the host platform^M
**^M
** Description:^M
** PR_GetRandomNoise() provides, depending on platform, a random value.^M
** The length of the random value is dependent on platform and the^M
** platform's ability to provide a random value at that moment.^M
**^M
** The intent of PR_GetRandomNoise() is to provide a "seed" value for a^M
** another random number generator that may be suitable for^M
** cryptographic operations. This implies that the random value^M
** provided may not be, by itself, cryptographically secure. The value^M
** generated by PR_GetRandomNoise() is at best, extremely difficult to^M
** predict and is as non-deterministic as the underlying platfrom can^M
** provide.^M
**^M
** Inputs:^M
**   buf -- pointer to a caller supplied buffer to contain the^M
**          generated random number. buf must be at least as large as^M
**          is specified in the 'size' argument.^M
**^M
**   size -- the requested size of the generated random number^M
**^M
** Outputs:^M
**   a random number provided in 'buf'.^M
**^M
** Returns:^M
**   PRSize value equal to the size of the random number actually^M
**   generated, or zero. The generated size may be less than the size^M
**   requested. A return value of zero means that PR_GetRandomNoise() is^M
**   not implemented on this platform, or there is no available noise^M
**   available to be returned at the time of the call.^M
**^M
** Restrictions:^M
**   Calls to PR_GetRandomNoise() may use a lot of CPU on some platforms.^M
**   Some platforms may block for up to a few seconds while they^M
**   accumulate some noise. Busy machines generate lots of noise, but^M
**   care is advised when using PR_GetRandomNoise() frequently in your^M
**   application.^M
**^M
** History:^M
**   Parts of the model dependent implementation for PR_GetRandomNoise()^M
**   were taken in whole or part from code previously in Netscape's NSS^M
**   component.^M
**^M
*/^M
NSPR_API(PRSize) PR_GetRandomNoise( ^M
    void    *buf,^M
    PRSize  size^M
);^M
^M
PR_END_EXTERN_C^M
^M
#endif /* prrng_h___ */^M
/* end prrng.h */^M
