/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*- */^M
/* ^M
 * The contents of this file are subject to the Mozilla Public^M
 * License Version 1.1 (the "License"); you may not use this file^M
 * except in compliance with the License. You may obtain a copy of^M
 * the License at http://www.mozilla.org/MPL/^M
 * ^M
 * Software distributed under the License is distributed on an "AS^M
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or^M
 * implied. See the License for the specific language governing^M
 * rights and limitations under the License.^M
 * ^M
 * The Original Code is the Netscape Portable Runtime (NSPR).^M
 * ^M
 * The Initial Developer of the Original Code is Netscape^M
 * Communications Corporation.  Portions created by Netscape are ^M
 * Copyright (C) 1998-2000 Netscape Communications Corporation.  All^M
 * Rights Reserved.^M
 * ^M
 * Contributor(s):^M
 * ^M
 * Alternatively, the contents of this file may be used under the^M
 * terms of the GNU General Public License Version 2 or later (the^M
 * "GPL"), in which case the provisions of the GPL are applicable ^M
 * instead of those above.  If you wish to allow use of your ^M
 * version of this file only under the terms of the GPL and not to^M
 * allow others to use your version of this file under the MPL,^M
 * indicate your decision by deleting the provisions above and^M
 * replace them with the notice and other provisions required by^M
 * the GPL.  If you do not delete the provisions above, a recipient^M
 * may use your version of this file under either the MPL or the^M
 * GPL.^M
 */^M
^M
/*^M
** File:		prrwlock.h^M
** Description:	API to basic reader-writer lock functions of NSPR.^M
**^M
**/^M
^M
#ifndef prrwlock_h___^M
#define prrwlock_h___^M
^M
#include "prtypes.h"^M
^M
PR_BEGIN_EXTERN_C^M
^M
/*^M
 * PRRWLock --^M
 *^M
 *	The reader writer lock, PRRWLock, is an opaque object to the clients^M
 *	of NSPR.  All routines operate on a pointer to this opaque entity.^M
 */^M
^M
^M
typedef struct PRRWLock PRRWLock;^M
^M
#define	PR_RWLOCK_RANK_NONE	0^M
^M
^M
/***********************************************************************^M
** FUNCTION:    PR_NewRWLock^M
** DESCRIPTION:^M
**  Returns a pointer to a newly created reader-writer lock object.^M
** INPUTS:      Lock rank^M
**				Lock name^M
** OUTPUTS:     void^M
** RETURN:      PRRWLock*^M
**   If the lock cannot be created because of resource constraints, NULL^M
**   is returned.^M
**  ^M
***********************************************************************/^M
NSPR_API(PRRWLock*) PR_NewRWLock(PRUint32 lock_rank, const char *lock_name);^M
^M
/***********************************************************************^M
** FUNCTION:    PR_DestroyRWLock^M
** DESCRIPTION:^M
**  Destroys a given RW lock object.^M
** INPUTS:      PRRWLock *lock - Lock to be freed.^M
** OUTPUTS:     void^M
** RETURN:      None^M
***********************************************************************/^M
NSPR_API(void) PR_DestroyRWLock(PRRWLock *lock);^M
^M
/***********************************************************************^M
** FUNCTION:    PR_RWLock_Rlock^M
** DESCRIPTION:^M
**  Apply a read lock (non-exclusive) on a RWLock^M
** INPUTS:      PRRWLock *lock - Lock to be read-locked.^M
** OUTPUTS:     void^M
** RETURN:      None^M
***********************************************************************/^M
NSPR_API(void) PR_RWLock_Rlock(PRRWLock *lock);^M
^M
/***********************************************************************^M
** FUNCTION:    PR_RWLock_Wlock^M
** DESCRIPTION:^M
**  Apply a write lock (exclusive) on a RWLock^M
** INPUTS:      PRRWLock *lock - Lock to write-locked.^M
** OUTPUTS:     void^M
** RETURN:      None^M
***********************************************************************/^M
NSPR_API(void) PR_RWLock_Wlock(PRRWLock *lock);^M
^M
/***********************************************************************^M
** FUNCTION:    PR_RWLock_Unlock^M
** DESCRIPTION:^M
**  Release a RW lock. Unlocking an unlocked lock has undefined results.^M
** INPUTS:      PRRWLock *lock - Lock to unlocked.^M
** OUTPUTS:     void^M
** RETURN:      void^M
***********************************************************************/^M
NSPR_API(void) PR_RWLock_Unlock(PRRWLock *lock);^M
^M
PR_END_EXTERN_C^M
^M
#endif /* prrwlock_h___ */^M
