/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*- */^M
/* ^M
 * The contents of this file are subject to the Mozilla Public^M
 * License Version 1.1 (the "License"); you may not use this file^M
 * except in compliance with the License. You may obtain a copy of^M
 * the License at http://www.mozilla.org/MPL/^M
 * ^M
 * Software distributed under the License is distributed on an "AS^M
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or^M
 * implied. See the License for the specific language governing^M
 * rights and limitations under the License.^M
 * ^M
 * The Original Code is the Netscape Portable Runtime (NSPR).^M
 * ^M
 * The Initial Developer of the Original Code is Netscape^M
 * Communications Corporation.  Portions created by Netscape are ^M
 * Copyright (C) 1998-2000 Netscape Communications Corporation.  All^M
 * Rights Reserved.^M
 * ^M
 * Contributor(s):^M
 * ^M
 * Alternatively, the contents of this file may be used under the^M
 * terms of the GNU General Public License Version 2 or later (the^M
 * "GPL"), in which case the provisions of the GPL are applicable ^M
 * instead of those above.  If you wish to allow use of your ^M
 * version of this file only under the terms of the GPL and not to^M
 * allow others to use your version of this file under the MPL,^M
 * indicate your decision by deleting the provisions above and^M
 * replace them with the notice and other provisions required by^M
 * the GPL.  If you do not delete the provisions above, a recipient^M
 * may use your version of this file under either the MPL or the^M
 * GPL.^M
 */^M
^M
#ifndef prwin16_h___^M
#define prwin16_h___^M
^M
/*^M
** Condition use of this header on platform.^M
*/^M
#if (defined(XP_PC) && !defined(_WIN32) && !defined(XP_OS2) && defined(MOZILLA_CLIENT)) || defined(WIN16)^M
#include <stdio.h>^M
^M
PR_BEGIN_EXTERN_C^M
/* ^M
** Win16 stdio special case.^M
** To get stdio to work for Win16, all calls to printf() and related^M
** things must be called from the environment of the .EXE; calls to^M
** printf() from the .DLL send output to the bit-bucket.^M
**^M
** To make sure that PR_fprintf(), and related functions, work correctly,^M
** the actual stream I/O to stdout, stderr, stdin must be done in the^M
** .EXE. To do this, a hack is placed in _MD_Write() such that the^M
** fd for stdio handles results in a call to the .EXE.^M
**^M
** file w16stdio.c contains the functions that get called from NSPR^M
** to do the actual I/O. w16stdio.o must be statically linked with^M
** any application needing stdio for Win16.^M
**^M
** The address of these functions must be made available to the .DLL^M
** so he can call back to the .EXE. To do this, function ^M
** PR_MD_RegisterW16StdioCallbacks() is called from the .EXE.^M
** The arguments are the functions defined in w16stdio.c^M
** At runtime, MD_Write() calls the registered functions, if any^M
** were registered.^M
**^M
** prinit.h contains a macro PR_STDIO_INIT() that calls the registration^M
** function for Win16; For other platforms, the macro is a No-Op.^M
**^M
** Note that stdio is not operational at all on Win16 GUI applications.^M
** This special case exists to provide stdio capability from the NSPR^M
** .DLL for command line applications only. NSPR's test cases are^M
** almost exclusively command line applications.^M
**^M
** See also: w16io.c, w16stdio.c^M
*/^M
typedef PRInt32 (PR_CALLBACK *PRStdinRead)( void *buf, PRInt32 amount);^M
typedef PRInt32 (PR_CALLBACK *PRStdoutWrite)( void *buf, PRInt32 amount);^M
typedef PRInt32 (PR_CALLBACK *PRStderrWrite)( void *buf, PRInt32 amount);^M
^M
NSPR_API(PRStatus)^M
PR_MD_RegisterW16StdioCallbacks( ^M
    PRStdinRead inReadf,            /* i: function pointer for stdin read       */^M
    PRStdoutWrite outWritef,        /* i: function pointer for stdout write     */^M
    PRStderrWrite errWritef         /* i: function pointer for stderr write     */^M
    );^M
^M
NSPR_API(PRInt32)^M
_PL_W16StdioWrite( void *buf, PRInt32 amount );^M
^M
NSPR_API(PRInt32)^M
_PL_W16StdioRead( void *buf, PRInt32 amount );^M
^M
#define PR_STDIO_INIT() PR_MD_RegisterW16StdioCallbacks( \^M
    _PL_W16StdioRead, _PL_W16StdioWrite, _PL_W16StdioWrite ); \^M
    PR_INIT_CALLBACKS();^M
^M
/*^M
** Win16 hackery.^M
**^M
*/^M
struct PRMethodCallbackStr {^M
    int     (PR_CALLBACK *auxOutput)(const char *outputString);^M
    size_t  (PR_CALLBACK *strftime)(char *s, size_t len, const char *fmt, const struct tm *p);^M
    void *  (PR_CALLBACK *malloc)( size_t size );^M
    void *  (PR_CALLBACK *calloc)(size_t n, size_t size );^M
    void *  (PR_CALLBACK *realloc)( void* old_blk, size_t size );^M
    void    (PR_CALLBACK *free)( void *ptr );^M
    void *  (PR_CALLBACK *getenv)( const char *name);^M
    int     (PR_CALLBACK *putenv)( const char *assoc);^M
//    void *  (PR_CALLBACK *perror)( const char *prefix );^M
};^M
^M
NSPR_API(void) PR_MDRegisterCallbacks(struct PRMethodCallbackStr *);^M
^M
int PR_CALLBACK _PL_W16CallBackPuts( const char *outputString );^M
size_t PR_CALLBACK _PL_W16CallBackStrftime( ^M
    char *s, ^M
    size_t len, ^M
    const char *fmt,^M
    const struct tm *p );^M
void * PR_CALLBACK _PL_W16CallBackMalloc( size_t size );^M
void * PR_CALLBACK _PL_W16CallBackCalloc( size_t n, size_t size );^M
void * PR_CALLBACK _PL_W16CallBackRealloc( ^M
    void *old_blk, ^M
    size_t size );^M
void   PR_CALLBACK _PL_W16CallBackFree( void *ptr );^M
void * PR_CALLBACK _PL_W16CallBackGetenv( const char *name );^M
int PR_CALLBACK _PL_W16CallBackPutenv( const char *assoc );^M
^M
/*^M
** Hackery! ^M
**^M
** These functions are provided as static link points.^M
** This is to satisfy the quick port of Gromit to NSPR 2.0^M
** ... Don't do this! ... alas, It may never go away.^M
** ^M
*/^M
NSPR_API(int)     PR_MD_printf(const char *, ...);^M
NSPR_API(void)    PR_MD_exit(int);^M
NSPR_API(size_t)  PR_MD_strftime(char *, size_t, const char *, const struct tm *); ^M
NSPR_API(int)     PR_MD_sscanf(const char *, const char *, ...);^M
NSPR_API(void*)   PR_MD_malloc( size_t size );^M
NSPR_API(void*)   PR_MD_calloc( size_t n, size_t size );^M
NSPR_API(void*)   PR_MD_realloc( void* old_blk, size_t size );^M
NSPR_API(void)    PR_MD_free( void *ptr );^M
NSPR_API(char*)   PR_MD_getenv( const char *name );^M
NSPR_API(int)     PR_MD_putenv( const char *assoc );^M
NSPR_API(int)     PR_MD_fprintf(FILE *fPtr, const char *fmt, ...);^M
^M
#define PR_INIT_CALLBACKS()                         \^M
    {                                               \^M
        static struct PRMethodCallbackStr cbf = {   \^M
            _PL_W16CallBackPuts,                    \^M
            _PL_W16CallBackStrftime,                \^M
            _PL_W16CallBackMalloc,                  \^M
            _PL_W16CallBackCalloc,                  \^M
            _PL_W16CallBackRealloc,                 \^M
            _PL_W16CallBackFree,                    \^M
            _PL_W16CallBackGetenv,                  \^M
            _PL_W16CallBackPutenv,                  \^M
        };                                          \^M
        PR_MDRegisterCallbacks( &cbf );             \^M
    }^M
^M
^M
/*^M
** Get the exception context for Win16 MFC applications threads^M
*/^M
NSPR_API(void *) PR_W16GetExceptionContext(void);^M
/*^M
** Set the exception context for Win16 MFC applications threads^M
*/^M
NSPR_API(void) PR_W16SetExceptionContext(void *context);^M
^M
PR_END_EXTERN_C^M
#else^M
/*^M
** For platforms other than Win16, define^M
** PR_STDIO_INIT() as a No-Op.^M
*/^M
#define PR_STDIO_INIT()^M
#endif /* WIN16 || MOZILLA_CLIENT */^M
^M
#endif /* prwin16_h___ */^M
^M
^M
^M
^M
^M
^M
^M
^M
